#include	<u.h>
#include	<libc.h>
#include	<bio.h>

uvlong	x;
vlong	va;
vlong	vb;
uvlong	ua;
uvlong	ub;

void
arshift(void)
{
	union { struct {ulong hi; ulong lo; }; vlong v; } u;

	u.v = va;
	u.lo >>= 1;
	if(u.hi & 1)
		u.lo |= 0x80000000;
	if(u.hi & 0x80000000)
		u.hi = (u.hi>>1) | 0x80000000;
	else
		u.hi >>= 1;
	va = u.v;
}

void
artest(void)
{
	long i;
	int j, c;
	ulong x1, x2;

	srand(time(0));
	for(i=0; i<100000; i++) {
		x1 = (lrand() << 10) ^ lrand();
		x2 = (lrand() << 10) ^ lrand();
		c = nrand(64);
		x = ((uvlong)x1 << 32) | x2;

		va = x;
		vb = va >> c;

		for(j=0; j<c; j++)
			arshift();
		if(vb != va)
			print("%.8lux:%.8lux >> %d is %.8lux:%.8lux sb %.8lux:%.8lux\n",
				x, c, vb, va);
	}
}

void
lrshift(void)
{
	union { struct {ulong hi; ulong lo; }; vlong v; } u;

	u.v = ua;
	u.lo >>= 1;
	if(u.hi & 1)
		u.lo |= 0x80000000;
	u.hi >>= 1;
	ua = u.v;
}

void
lrtest(void)
{
	long i;
	int j, c;
	ulong x1, x2;

	srand(time(0));
	for(i=0; i<100000; i++) {
		x1 = (lrand() << 10) ^ lrand();
		x2 = (lrand() << 10) ^ lrand();
		c = nrand(64);
		x = ((uvlong)x1 << 32) | x2;

		ua = x;
		ub = ua >> c;

		for(j=0; j<c; j++)
			lrshift();
		if(ub != ua)
			print("%.8lux:%.8lux >> %d is %.8lux:%.8lux sb %.8lux:%.8lux\n",
				x, c, ub, ua);
	}
}

void
lshift(void)
{
	union { struct {ulong hi; ulong lo; }; vlong v; } u;

	u.v = ua;
	u.hi <<= 1;
	if(u.lo & 0x80000000)
		u.hi |= 1;
	u.lo <<= 1;
	ua = u.v;
}

void
ltest(void)
{
	long i;
	int j, c;
	ulong x1, x2;

	srand(time(0));
	for(i=0; i<100000; i++) {
		x1 = (lrand() << 10) ^ lrand();
		x2 = (lrand() << 10) ^ lrand();
		c = nrand(64);
		x = ((uvlong)x1 << 32) | x2;

		ua = x;
		ub = ua << c;

		for(j=0; j<c; j++)
			lshift();
		if(ub != ua)
			print("%.8lux:%.8lux << %d is %.8lux:%.8lux sb %.8lux:%.8lux\n",
				x, c, ub, ua);
	}
}

void
main(void)
{

	print("arith right shift\n");
	artest();

	print("logical right shift\n");
	artest();

	print("left shift\n");
	ltest();

	exits(0);
}
